require 'middleclass'
require 'middleclass-commons'
require 'LUBE'
require 'Tserial'

function love.load()
	username = io.read()
	host = "localhost"
	port = 1234
	client = lube.udpClient()
	client.callbacks.recv = function(d) recv(d) end
	client.handshake = "handshake"
	if client:connect(host, port, true) then
		print('Connect to ' .. host .. ': ' .. port)
	end
	

	Player = class('Player')
	function Player:initialize(x, y, width, height, speed, color, state, airtime)
		self.x = x
		self.y = y
		self.width = width 
		self.height = height
		self.speed = speed
		self.color = color
		self.state = state
		self.airtime = airtime
	end

	xlist = {200}
	ylist = {200}

	p = Player:new(xlist[1], ylist[1], 20, 20, 200, {255, 255, 0, 255}, 'falling', 0)
	
	g = love.graphics
end

function recv(data)
	print('Server data received: ' .. data)
end

function love.update(dt)
	client:update(dt)

	if love.keyboard.isDown("right") then
		p.x = p.x + (p.speed * dt)
		local x = {'x', p.x}
		xmessage = Tserial.pack(x, false)
		client:send(xmessage)
	elseif love.keyboard.isDown("left") then
		p.x =  p.x - (p.speed * dt)
		local x = {'x', p.x}
		xmessage = Tserial.pack(x, false)
		client:send(xmessage)
	end

	if love.keyboard.isDown("up") then
		p.state = 'jumping'
	end

	if p.state == 'jumping' and p.airtime <= 20 then
		p.y = p.y - ((p.speed * 2) * dt)
		p.airtime = p.airtime + (dt * 60)
	--	client:send('y' .. p.y)
	end

	if p.airtime >= 20 then
		p.state = 'falling'
	end

	if p.state == 'falling' or p.state == 'jumping' then
		p.y = p.y + 4
	--	client:send('y' .. p.y)
	end

	if p.y > 580 then
		p.state = 'standing'
		p.airtime = 0
		p.y = 580
	end

end

function love.draw()
	g.setColor(255, 255, 0, 255)
	g.rectangle("fill", p.x, p.y, p.width, p.height)
end
